/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Super Drag and Go.
 *
 * The Initial Developer of the Original Code is
 * Wladimir Palant.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */
var sdagTrailCont;
var sdagTrailCnt = null;
var sdagDocX,sdagDocY;


function sdagStartTrail(e) {
  const xhtmlNS = "http://www.w3.org/1999/xhtml";
  var targetDoc = e.originalTarget.ownerDocument;
  if ((targetDoc.contentType == "application/vnd.mozilla.xul+xml") || targetDoc.contentType.indexOf("image/") != -1){
	sdagTrailCnt = null;
	return;
  }
  if (targetDoc.defaultView.top instanceof Window) targetDoc = targetDoc.defaultView.top.document;
  var insertionNode = (targetDoc.documentElement) ? targetDoc.documentElement : targetDoc;
  var docBox = targetDoc.getBoxObjectFor(insertionNode);
  sdagDocX = docBox.screenX;
  sdagDocY = docBox.screenY;

  var geckoVers = parseFloat(window.navigator.userAgent.substring(window.navigator.userAgent.lastIndexOf("rv:") + 3));
  var sdagFxV1_0 = !isNaN(geckoVers) && geckoVers < 1.8;
  if (sdagFxV1_0) {
     sdagDocX -= targetDoc.defaultView.pageXOffset;
     sdagDocY -= targetDoc.defaultView.pageYOffset;
  }
  sdagTrailCont = targetDoc.createElementNS(xhtmlNS, "sdagTrailContainer");
  insertionNode.appendChild(sdagTrailCont);
  sdagTrailCnt = 0;
  setTimeout(sdagEraseTrail, 3000);
}

function sdagDrawTrail(e,aText) {
  if (sdagTrailCont == null) return;
  var currentX = sdagTrailX - sdagDocX;
  var currentY = sdagTrailY - sdagDocY;
  if(sdagTrailCont.hasChildNodes()){
    if(sdagTrailCnt % 3 == 0){
      var Tooltip = sdagTrailCont.lastChild;
      Tooltip.textContent = aText;
      var x = currentX - IndicatorSet[0];
      var y = currentY - 3 * IndicatorSet[0];
      if(sdagMoveEnable){
	var tStyle = Tooltip.style;
	tStyle.left = x > 0 ? x + "px" : "0px";
	tStyle.top = y > 0 ? y + "px" : "0px";
      }
    }
  }else{
      if(sdagMoveEnable)
	appendDot(currentX, currentY);
      else
	appendDot(sdagStartDragX - sdagDocX, sdagStartDragY - sdagDocY);
  }
  function appendDot(x, y) {
	var dot = document.createElement ("DIV");
	dot.id = "sdagTrail";
	dot.setAttribute("style", "font-weight: bold;padding: 3px;border: 1px solid #E0E0E0;cursor:inherit;z-index:10000;position:absolute;");
	var dStyle = dot.style;
	dStyle.left = x - IndicatorSet[0] + "px";
	dStyle.top = y - 3 * IndicatorSet[0] + "px";
	dStyle.MozBorderRadius = IndicatorSet[0]/2 + "px";
	dStyle.background = IndicatorSet[3];
	dStyle.opacity = IndicatorSet[1]/10;
	dStyle.color = IndicatorSet[2];
	dStyle.fontSize = IndicatorSet[0] + "px";
	var font = document.createTextNode(aText);
	dot.appendChild(font);
	sdagTrailCont.appendChild(dot);
  }
}

function sdagEraseTrail() {
  if (sdagTrailCont && sdagTrailCont.parentNode)
    sdagTrailCont.parentNode.removeChild(sdagTrailCont);
  sdagTrailCont = sdagTrailCnt = null;
  sdagDocX = sdagDocY = null;
}

function sdagIsUnformattedXML(aDoc) {
  return aDoc.contentType.indexOf("/xml") != -1 && aDoc.styleSheets && aDoc.styleSheets.length && 
         aDoc.styleSheets[0].href.substr(-31) == "/content/xml/XMLPrettyPrint.css";
}
