/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Super Drag and Go.
 *
 * The Initial Developer of the Original Code is
 * Wladimir Palant.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */
//////////// Drag and Dorp bserver: replace contentAreaDNDObserver with it. ///////////////////
var superDragDNDObserver = {
  StartAlready:null,
  onDragStart: function(aEvent, aXferData, aDragAction){
	this.OverAlready = false;
	this.StartAlready = true;
	sdagStartDragX = aEvent.screenX;
	sdagStartDragY = aEvent.screenY;
	if(sdagEnableIndicator){
	   sdagStartTrail(aEvent);
	}
	var target = aEvent.originalTarget;
	if (!/^img$/i.test(target.localName)) return;
	for (var obj = target.parentNode; obj && !/^a$/i.test(obj.localName); obj = obj.parentNode);
	   var url = ((obj)?obj.href:null) || target.src;
	if (!url) return;
	var caption = ((obj)?obj.title:null) || target.alt || target.title || url.replace(/^.*\//, "") || url;
	aXferData.data = new TransferData();
	aXferData.data.addDataForFlavour("text/x-moz-url", url +"\n"+ "[Image] " + caption +"\n"+ target.src);
	aXferData.data.addDataForFlavour("text/unicode", url);
	aXferData.data.addDataForFlavour("text/html", '<a href="' + url + '">' + caption + '</a>');

	aDragAction.action = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY |
			 Components.interfaces.nsIDragService.DRAGDROP_ACTION_MOVE |
			 Components.interfaces.nsIDragService.DRAGDROP_ACTION_LINK;
  },

  onDragOver: function(aEvent, aFlavour, aDragSession){
    aDragSession.canDrop=true;
    var SourceNode = aDragSession.sourceNode;
    if(!this.StartAlready || !SourceNode) return;
    if((aDragSession.sourceDocument != aEvent.view.document) && (SourceNode.id != "content")){
	this.StartAlready = false;
	return;
    }
    if(!this.OverAlready){
	var dragSession = aDragSession.getCurrentSession();
	var transfer = Components.classes["@mozilla.org/widget/transferable;1"].
			createInstance(Components.interfaces.nsITransferable);
	transfer.addDataFlavor("text/x-moz-url");
	dragSession.getData (transfer, 0);
	var dataObj = new Object();
	var flavor = new Object();
	var len = new Object();
	try{
            transfer.getAnyTransferData(flavor, dataObj, len);   
	} catch (ex) {}
	var uri = superDrag.SelectedText
	if(uri && !superDrag.forceAsURL(uri)){
	    sdagText = sdagURL = uri;sdagSrc = null;
	    sdagAction = superDrag.Taction;
	}else if(dataObj.value){
	    dataObj = dataObj.value.QueryInterface(Components.interfaces.nsISupportsString);      
	    var sourceUri = dataObj.data.substring(0, len.value);
	    var DragData = sourceUri.split("\n");

	    uri = DragData[0];
	    if( superDrag.forceAsURL(uri)){
		sdagURL = superDrag.checkURI(aEvent, aDragSession, uri);
		var target = aEvent.originalTarget;
		if (/^img$/i.test(target.localName)){
		    sdagText = DragData[1] ? DragData[1] : DragData[0];
		    sdagSrc = DragData[2] ? DragData[2] : DragData[0];
		    sdagAction = superDrag.Iaction;
		}else if(/([^\/]+\.xpi)$/.test(uri)){
		    sdagSrc = RegExp.$1;
		    sdagText = DragData[1] ? DragData[1] : DragData[0];
		    sdagAction = superDrag.Xaction;
		}else{
		    sdagText = DragData[1] ? DragData[1] : DragData[0];
		    sdagAction = superDrag.Laction;
		    sdagSrc = null;
		}
	    }else{
		sdagText = sdagURL = uri;sdagSrc = null;
		sdagAction = superDrag.Taction;
	    }
	}
        this.OverAlready = true;
	sdagTrailX = aEvent.screenX;
	sdagTrailY = aEvent.screenY;
    }
    if(Math.abs(sdagTrailX - aEvent.screenX) > 1 || Math.abs(sdagTrailY - aEvent.screenY) > 1){
	var Message = superDrag.GetString("g."+sdagAction[superDrag.Direction(aEvent,sdagAction[0])]);
	sdagStatusMessage("Super Drag and Go: " + Message, 3000);
	if((sdagTrailCnt != null) && (++sdagTrailCnt > IndicatorSet[4])){
	   sdagTrailX = aEvent.screenX;
	   sdagTrailY = aEvent.screenY;
	   sdagDrawTrail(aEvent ,Message);
	}
    }else if((sdagTrailCnt != null) && (sdagTrailCnt < IndicatorSet[4])){
	if((sdagTrailX == aEvent.screenX) && (sdagTrailY == aEvent.screenY)){
	    sdagTrailCnt += 30;
	    if(sdagTrailCnt >= IndicatorSet[4]){
		var Message = superDrag.GetString("g."+sdagAction[superDrag.Direction(aEvent,sdagAction[0])]);
		sdagDrawTrail(aEvent ,Message);
	    }
	}
    }
  },
  
  onDrop: function (aEvent, aDropData, aDragSession){
///////////////Drag and Drop from Firefox.////////////
    if(sdagEnableIndicator) sdagEraseTrail();
    if(this.StartAlready && aDragSession.sourceNode){
	switch (document.firstChild.getAttribute('windowtype')){
	    case "navigator:browser":
		superDrag.DoGesture(aEvent);
		break;
	    case "navigator:view-source":
        	viewSource(aDropData);
		break;
	}
///////////////Drag and Drop from another application.////////////
    }else{
	var url = transferUtils.retrieveURLFromData(aDropData.data, aDropData.flavour.contentType);
	// valid urls don't contain spaces ' '; if we have a space it
	// isn't a valid url, or if it's a javascript: or data: url,
	// bail out
	if (!url || !url.length || url.indexOf(" ", 0) != -1 ||
	       /^\s*(javascript|data):/.test(url))
	return;

	getBrowser().dragDropSecurityCheck(aEvent, aDragSession, url);

	switch (document.documentElement.getAttribute('windowtype')) {
	    case "navigator:browser":
		if(aDragSession.sourceNode){
		    superDrag.Open(url ,OpenIn[1]);
		}else if((aEvent.target.localName == "INPUT") && (aEvent.target.type == "file")){
		   try{
		    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
		    var fileHandler = ioService.getProtocolHandler("file")
                                 .QueryInterface(Components.interfaces.nsIFileProtocolHandler);

		    var aFile = fileHandler.getFileFromURLSpec(url);
		    aEvent.target.value = aFile.path;
		   }catch(e){alert("Super DragAndGo fails to Get File Path");}
		}else{
		    if((/(^http|\.(txt|ini|xml|s?html?|sgml?|css|js|jpg|png|gif|bmp)$)/i.test(url)) || ((/[\/]$/i.test(url)) && !(/\.lnk[\/]$/i.test(url))))
			superDrag.Open(url ,OpenIn[0]);
		    else
			superDrag.Open(url ,"go-c");
		}
		break;
	    case "navigator:view-source":
		viewSource(url);
		break;
	}
    }
    aEvent.preventDefault();
    aEvent.preventBubble();
    aEvent.preventCapture();
    aEvent.stopPropagation();
    this.OverAlready = this.StartAlready = false;
    sdagAction = [];
    sdagText = sdagURL = sdagSrc = sdagStartDragX = sdagStartDragY = sdagTrailX = sdagTrailY = null;
  },

  getSupportedFlavours: function (){
      var flavourSet = new FlavourSet();
      flavourSet.appendFlavour("text/x-moz-url");
      flavourSet.appendFlavour("text/unicode");
      flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
      return flavourSet;
  }

}
//////////////////////////////////////////////////////////////////
var sdagAction = [0,"search-f","search-f","search-f","search-f"];
var OpenIn = ["go-f","go-f"];
var sdagText,sdagURL,sdagSrc,sdagStatusBar,sdagStartDragX,sdagStartDragY,sdagTrailX,sdagTrailY,IndicatorSet;
var sdagEnableIndicator = false
var sdagMoveEnable = false;
var superDrag = {
  loaded: false,
  _Prefs: null,
  Taction : [0,"search-f","search-f","search-f","search-f"],
  Laction : [0,"go-f","go-f","go-f","go-f"],
  Iaction : [0,"save-Img","save-Img","save-Img","save-Img"],
  Xaction : [0,"install-xpi","install-xpi","install-xpi","install-xpi"],
         
  onLoad: function(){
     // Overwrite original functions with modified versions if not already done
     if(!this.loaded){
	contentAreaDNDObserver = superDragDNDObserver;
	getBrowser().addEventListener('draggesture', function(event) {nsDragAndDrop.startDrag(event, contentAreaDNDObserver);} , true);
	getBrowser().addEventListener('dragover', function(event) {nsDragAndDrop.dragOver(event, contentAreaDNDObserver);} , false);
	addPrefListener(SuperDragPrefListener);
	sdagStatusBar = document.getElementById("statusbar-display");
	superDrag.getPref();
	this.loaded = true;
     }
  },

  DoGesture: function (aEvent){
     //myDump(sdagText +"\n"+ sdagURL +"\n"+ sdagSrc +"\n"+ sdagStartDragX +"\n"+ sdagStartDragY);
     eval(this.Gesture[sdagAction[this.Direction(aEvent,sdagAction[0])]]);
  },

  Direction : function(aEvent , mode){
	var EndDragX = aEvent.screenX;
	var EndDragY = aEvent.screenY;
	var directionX = (EndDragX - sdagStartDragX)>0 ? 1 : 2 ;
	var directionY = (EndDragY - sdagStartDragY)>0 ? 3 : 4 ;
	if(mode == 0)
	    var direction = (Math.abs(EndDragX - sdagStartDragX) - Math.abs(EndDragY - sdagStartDragY))>0 ? directionX : directionY ;
	else if(mode == 1)
	    var direction = directionY;
	else if(mode == 2)
	    var direction = directionX;
	return direction;
  },

  /*Direction2 : function(aEvent){
	var EndDragX = aEvent.screenX;
	var EndDragY = aEvent.screenY;
	var X = (EndDragX - sdagStartDragX);
	var Y = (EndDragY - sdagStartDragY);
	if((2*Y > 5*X) && (2*Y > -5*X))
		var direction = "Down";
	else if((5*Y < 2*X) && (5*Y > -2*X))
		var direction = "Right";
	else if((2*Y < 5*X) && (2*Y < -5*X))
		var direction = "Up";
	else if((5*Y < -2*X) && (5*Y > 2*X))
		var direction = "Left";
	else if((2*Y < 5*X) && (5*Y > 2*X))
		var direction = "DownRight";
	else if((5*Y < -2*X) && (2*Y > -5*X))
		var direction = "UpRight";
	else if((5*Y < 2*X) && (2*Y > 5*X))
		var direction = "UpLeft";
	else if((2*Y < -5*X) && (5*Y > -2*X))
		var direction = "DownLeft";
	else
		var direction = "Undentify";
	return direction;
  },*/

  Gesture:{
	"do-nothing" : "null;",
	"search-f" : "this.Search(sdagText ,2);",
	"search-h" : "this.Search(sdagText ,1);",
	"search-c" : "this.Search(sdagText ,0);",
	"conquery" : "this.Conquery(sdagText, aEvent);",
	"paste-searchbar" : "this.mSearchBar(sdagText,1);",
	"delete-searchbar" : "this.mSearchBar(sdagText,0);",
	"go-f" : "this.Open(sdagURL ,'go-f');",
	"go-h" : "this.Open(sdagURL ,'go-h');",
	"go-c" : "this.Open(sdagURL ,'go-c');",
	"addbookmark" : "BookmarksUtils.addBookmark(sdagURL ,sdagText );",
	"save-link" : "saveURL( sdagURL, sdagSrc, null, true );",
	"save-xpi" : "saveURL( sdagURL, sdagSrc, null, true );",
	"save-df-xpi" : "this.SaveXpiDf(sdagURL);",
	"install-xpi" : "this.InstallXpi(sdagURL, sdagSrc);",
	"save-Img" : "this.SaveImg(sdagSrc);",
	"save-df-Img" : "this.SaveImgDf(sdagSrc)",
	"download-Img":"this.DownLoad(sdagSrc);"
  },
//////////// Each Gesture Functions ///////////////////////
  SaveImg: function(aSrc){
	saveURL( aSrc , null, "SaveImageTitle", false );
  },

  InstallXpi: function(aURI, aSrc){
	eval("InstallTrigger.install({ '" + aSrc + "' : aURI })");
  },

  DownLoad: function(aSrc){
	if(confirm(this.GetString("download_image_warning")))
	    saveURL( aSrc, null, null, false, true);
  },

  SaveImgDf: function(aSrc){
	if(this.Prefs.getBoolPref('ConfirmSavingImg')){
	    if(confirm(this.GetString("save_image_warning")))
		this.saveImage(aSrc , 'Imgdefaultfolder');
	    }else
		this.saveImage(aSrc , 'Imgdefaultfolder');
  },

  SaveXpiDf: function(aURL){
	if(this.Prefs.getBoolPref('ConfirmSavingXpi')){
	    if(confirm(this.GetString("save_xpi_warning")))
		this.saveImage(aURL , 'Xpidefaultfolder');
	    }else
		this.saveImage(aURL , 'Xpidefaultfolder');
  },

  Conquery: function(aText, aEvent){
	document.popupNode = aEvent.target;
	cqrPageSelection = aText;
	cqrShowHotmenu(true, aEvent.clientX, aEvent.clientY);
  },

  Open: function(aURL,mode){
	var postData = { };
	var uri = getShortcutOrURI(aURL, postData);
	if(mode == "go-c")
	    getBrowser().loadURI(uri);
	else
	    var newTab = getBrowser().addTab(uri);
	if(mode == "go-f")
	    getBrowser().selectedTab = newTab;
  },

  mSearchBar: function(aText ,mode){
	if(!this.searchBox.ref)return;
	if(mode == 0)aText = "";
	this.searchBox.value = aText;
  },

  Search: function (aText,mode){
	var openURL = this.getSearchUrl(aText);
	if(mode == 0)
	    getBrowser().loadURI(openURL);
	else
	    var newTab = getBrowser().addTab(openURL);
	if(mode == 2)
	    getBrowser().selectedTab = newTab;
  },
//////////////////////////////////////////////////////


  checkURI : function(aEvent, aDragSession, aURI){
    if (/^\s*(javascript|data):/.test(aURI))
	return "";
    var uriStr = aURI.replace(/^\s*|\s*$/g, '');
    uriStr = this.fixupSchemer(uriStr);
    var uri = null;
    try{
	uri = makeURI(uriStr ,null ,null);
    }catch(e) {}
    if(uri){
	try {
	   const secMan = Components.classes["@mozilla.org/scriptsecuritymanager;1"]
			.getService(Components.interfaces.nsIScriptSecurityManager);
	   const nsIScriptSecMan = Components.interfaces.nsIScriptSecurityManager;
	   secMan.checkLoadURI(getBrowser().currentURI, uri, nsIScriptSecMan.DISALLOW_SCRIPT_OR_DATA);
	   uriStr = uri.spec;
	} catch (ex) {uriStr = "";}
    }
    return uriStr;
  },

  getDownloadFolder: function(afolder){
  	const nsILocalFile = Components.interfaces.nsILocalFile;
	const directoryService=Components.classes['@mozilla.org/file/directory_service;1']
		.getService(Components.interfaces.nsIProperties);
    	var dir = null;    						 	
	try{
	    dir = decodeURIComponent(this.Prefs.getCharPref(afolder));
            if(/^(\.)/.test(dir)){
		const fileOrDir = directoryService.get('CurProcD', Components.interfaces.nsIFile);
		var FFdir = fileOrDir.QueryInterface(Components.interfaces.nsILocalFile).path;
		FFdir += "\\"
		dir = FFdir.concat(dir);
	    }
	}catch (e){}
	
	if(dir == null||dir.length==0){
	    function getDesktopKey(){      
      		return "DeskV";
        	return "Home";
	    }
      	    const fileLocator = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);    
      	    dir = fileLocator.get(getDesktopKey(), Components.interfaces.nsILocalFile);
      	    return dir.path;
	}
	return dir;	
  },

  saveImage: function(src,afolder){
      var fileName = src.substring(src.lastIndexOf('/')+1, src.length);
      const fileSaving = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      var path = this.getDownloadFolder(afolder) + "\\";
      fileSaving.initWithPath(path);//alert("get out saveImage");
      
      if (!fileSaving.exists()){
         alert(this.GetString("folder_not_exist"));
         return;
      }
      fileSaving.initWithPath(path + fileName);
      var i = 1;
      var newFileName=fileName;
      
      while (fileSaving.exists()){
	if (fileName.indexOf('.') != -1){
            var ext = fileName.substring(fileName.lastIndexOf('.'), fileName.length);
            var file = fileName.substring(0, fileName.length - ext.length);
            newFileName = file + "-" + i + ext;
            fileSaving.initWithPath(path + newFileName);
	}else
             fileSaving.initWithPath(path + fileName + i);
	i++;
      }
      const cacheKey  = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
      cacheKey.data = src;

      const urifix  = Components.classes['@mozilla.org/docshell/urifixup;1'].getService(Components.interfaces.nsIURIFixup);
      var uri     = urifix.createFixupURI(src, 0);
      var hosturi = null;

      if (uri.host.length > 0) {
         hosturi = urifix.createFixupURI(uri.host, 0);
      }

      const persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].
			createInstance(Components.interfaces.nsIWebBrowserPersist);
      persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_FROM_CACHE 
			|| Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_CLEANUP_ON_FAILURE;
      persist.saveURI(uri, cacheKey, hosturi, null, null, fileSaving);

      function StatusLabel(){       			
      	var SaveLabel="The file has been saved to "+ path + " as " + newFileName ; 					
     	document.getElementById('statusbar-display').label = SaveLabel;
      }
      setTimeout(StatusLabel,100);
  },

  getSearchUrl: function(searchStr){
   var escapedSearchStr = encodeURIComponent(searchStr);
   if(this.searchBox.ref){
	var searchEngine = this.searchBox.ref.getAttribute('searchengine');
	if (searchEngine){
	    const iSearchService = Components.classes['@mozilla.org/rdf/datasource;1?name=internetsearch'].
				getService(Components.interfaces.nsIInternetSearchService);
	    return iSearchService.GetInternetSearchURL(searchEngine, escapedSearchStr, 0, 0, {value: 0});
	}else{
	    const sdagSearchService = Components.classes["@mozilla.org/browser/search-service;1"]
				.getService(Components.interfaces.nsIBrowserSearchService);
	    var engine = sdagSearchService.currentEngine;
	    if(engine){
		var submission = engine.getSubmission(searchStr);
		return submission.uri.spec;
	    }
	}
   }
   var defaultSearchURL = null;
   var navigatorRegionBundle = document.getElementById("bundle_browser_region");
   var fallbackDefaultSearchURL = navigatorRegionBundle.getString("fallbackDefaultSearchURL");
   try {
	defaultSearchURL = gPrefService.getComplexValue("browser.search.defaulturl",
				Components.interfaces.nsIPrefLocalizedString).data;
   } catch (ex) {}
   if(!defaultSearchURL)
	defaultSearchURL = fallbackDefaultSearchURL;
   defaultSearchURL += escapedSearchStr;
   return defaultSearchURL;
  },

  get SelectedText() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var str = focusedWindow.getSelection.call(focusedWindow).toString();
	return str;
  },

  forceAsURL : function(auri){
	var DomainName = /(\w+(\-+\w+)*\.)+\w{2,7}/ ;
	var HasSpace = /\S\s+\S/;
       	return DomainName.test(auri) && (!HasSpace.test(auri));
  },

  fixupSchemer : function(aURI) {
	var table = "ttp=>http,tp=>http,p=>http,ttps=>https,tps=>https,ps=>https";
	var regexp = new RegExp();
	if (aURI.match(regexp.compile(
				'^('+ table.replace(/=>[^,]+|=>[^,]+$/g, '')
						.replace(/\s*,\s*/g, '|')+
					'):',	'g'  )
		)) {
	    var target = RegExp.$1;
	    table.match(regexp.compile('(,|^)'+target+'=>([^,]+)'));
	    aURI = aURI.replace(target, RegExp.$2);
	}
	return aURI;
  },

  GetString : function(name) {
	const stringService = Components.classes["@mozilla.org/intl/stringbundle;1"].
			getService(Components.interfaces.nsIStringBundleService);
	var strings = stringService.createBundle("chrome://superdrag/locale/superdrag.properties");
	return strings.GetStringFromName(name);
  },

  get Prefs(){
	if (!this._Prefs) {
	   this._Prefs = Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefService).getBranch('superdrag.settings.');
	}
	return this._Prefs;
  },

  getPref:function(){
     try{
	 this.Taction = this.Prefs.getCharPref('textaction').split(" ");
	 this.Laction = this.Prefs.getCharPref('linkaction').split(" ");
	 this.Iaction = this.Prefs.getCharPref('imgaction').split(" ");
	 this.Xaction = this.Prefs.getCharPref('xpiaction').split(" ");
	sdagEnableIndicator = superDrag.Prefs.getBoolPref('enableIndicator');
	if(sdagEnableIndicator){
	   sdagMoveEnable = superDrag.Prefs.getBoolPref('moveEnable'); 
	   IndicatorSet = superDrag.Prefs.getCharPref('IndicatorSet').split(" ");
	   IndicatorSet[0] = parseInt(IndicatorSet[0]);
	   IndicatorSet[1] = parseInt(IndicatorSet[1]);
	   IndicatorSet[4] = parseInt(IndicatorSet[4]);
	}
	OpenIn = superDrag.Prefs.getCharPref('OpenIn').split(" ");
     }catch(e){}
  },
  
  searchBox: {
    get ref() {
      return document.getElementById("searchbar");
    },

    get value() {
      var textbox = document.getAnonymousElementByAttribute(this.ref, "class", "searchbar-textbox");
      if (textbox) {
        return textbox.inputField.value;
      }
    },

    set value(aValue) {
      var textbox = document.getAnonymousElementByAttribute(this.ref, "class", "searchbar-textbox");
      if (textbox) {
        textbox.inputField.value = aValue;
        /*
          XXXLegendre: We have to fire a "oninput" event
          because it appears that we cannot fire/catch an "input"
          event on the searchbar. It might be related to bug 281859.
        */
        var evt = document.createEvent("Events");
        evt.initEvent("oninput", true, true);
        this.ref.dispatchEvent(evt);
      }
    },

    exist: function() {
      return this.ref != null;
    }
  }
}

var SuperDragPrefListener = {
    domain  : 'superdrag.settings',
    observe : function(aSubject, aTopic, aPrefstring) {
        if (aTopic == 'nsPref:changed') 
	    superDrag.getPref();
    }
}

function addPrefListener(aObserver) {
    try {
        const pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranchInternal);
        pbi.addObserver(aObserver.domain, aObserver, false);
    } catch(e) {}
}

function sdagStatusMessage(msg, timeToClear) {
  if (!sdagStatusBar) return;
  sdagStatusBar.label = msg;
  if (timeToClear) {
     setTimeout(sdagStatusMessage, timeToClear, "", 0);
  }
}

function myDump(aMessage) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("SuperDrag: " + aMessage);
}

window.addEventListener('load', superDrag.onLoad, false);

